﻿using Luski.net.JsonTypes.BaseTypes;
using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

namespace Luski.net.JsonTypes;

internal class FriendRequestResult : STC
{
    [JsonPropertyName("channel")]
    [JsonInclude]
    public long? Channel { get; set; }
    [JsonPropertyName("id")]
    [JsonInclude]
    public long? Id { get; set; }
    [JsonPropertyName("result")]
    [JsonInclude]
    public bool? Result { get; set; }
}

[JsonSerializable(typeof(FriendRequestResult))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class FriendRequestResultContext : JsonSerializerContext
{

}
