using System;
using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Shared;

namespace Luski.net.JsonTypes;

public class LocalServerInfo
{
    [JsonInclude]
    [JsonPropertyName("alternate_servers")]
    public ServerData[] AlternateServers { get; set; } = Array.Empty<ServerData>();
}

[JsonSerializable(typeof(LocalServerInfo))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class LocalServerInfoContext : JsonSerializerContext
{

}