using System.Text.Json.Serialization;
using Luski.net.Enums;

namespace Luski.net.JsonTypes;

public class ServerStorageInfo
{
    [JsonInclude]
    [JsonPropertyName("cache_mode")]
    public CacheMode CacheMode { get; set; } = CacheMode.Encrypted;
    [JsonInclude]
    [JsonPropertyName("storage_id")]
    public long StorageID { get; set; } = default!;
    [JsonInclude]
    [JsonPropertyName("prevent_deletion")]
    public bool DontDelete { get; set; } = false;
}

[JsonSerializable(typeof(ServerStorageInfo))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = true)]
internal partial class ServerStorageInfoContext : JsonSerializerContext
{

}