﻿using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Enums;

namespace Luski.net.JsonTypes.BaseTypes;

public class BetterIncomingWSS
{
    [JsonPropertyName("type")]
    [JsonInclude]
    public DataType? Type { get; set; } = DataType.Token!;
    [JsonPropertyName("error")]
    [JsonInclude]
    public string Error { get; set; } = default!;
    [JsonPropertyName("data")]
    [JsonInclude]
    public object? Data { get; set; }
}

[JsonSerializable(typeof(BetterIncomingWSS))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false)]
public partial class BetterIncomingWSSContext : JsonSerializerContext
{

}
