﻿using Luski.net.Enums;
using Luski.net.JsonTypes.BaseTypes;
using System.Text.Json.Serialization;

namespace Luski.net.JsonTypes.WSS;

internal class WSSKeyExchange : IncomingWSS
{
    [JsonPropertyName("type")]
    [JsonInclude]
    new public DataType? Type { get; set; } = DataType.Key_Exchange;
    [JsonPropertyName("channel")]
    [JsonInclude]
    public long channel { get; set; } = default!;
    [JsonPropertyName("key")]
    [JsonInclude]
    public string key { get; set; } = default!;
    [JsonPropertyName("to")]
    [JsonInclude]
    public long? to { get; set; } = default!;
}

[JsonSerializable(typeof(WSSKeyExchange))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class WSSKeyExchangeContext : JsonSerializerContext
{

}
