﻿using Luski.net.Enums;
using Luski.net.JsonTypes.BaseTypes;
using System.Text.Json.Serialization;
using Luski.net.Interfaces;

namespace Luski.net.JsonTypes.WSS;

internal class WSSLogin : IncomingWSS, IServerEvent
{
    [JsonPropertyName("token")]
    [JsonInclude]
    public string Token { get; set; } = default!;
    [JsonPropertyName("session_token")]
    [JsonInclude]
    public string? SessionToken { get; set; } = default!;
    [JsonPropertyName("type")]
    [JsonInclude]
    new public DataType? Type { get; set; } = DataType.Login;
}

[JsonSerializable(typeof(WSSLogin))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class WSSLoginContext : JsonSerializerContext
{

}
