﻿using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.ServerToClient.HTTP;

namespace Luski.net.Structures.Main;

internal class SocketBulkMessage : STC

{
    [JsonPropertyName("messages")]
    [JsonInclude]
    public MainSocketMessage[]? Messages { get; set; } = default!;
}

[JsonSerializable(typeof(SocketBulkMessage))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
internal partial class SocketBulkMessageContext : JsonSerializerContext
{

}
